> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cortex.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a plugin

> Create a new plugin



## OpenAPI

````yaml /openapi/cortex_swagger.json post /api/v1/plugins
openapi: 3.0.1
info:
  description: >-
    The Cortex REST API provides programmatic access to the data in the catalog,
    Scorecards, and more.
  title: Cortex API
  version: v1
servers:
  - url: https://api.getcortexapp.com
    description: Cortex Cloud API host
security:
  - bearerAuth: []
tags:
  - name: API Keys
  - name: Audit Logs
  - name: Catalog Entities
  - name: Catalogs
  - name: Custom Data
  - name: Custom Data [Advanced]
  - name: Custom Events
  - name: Custom Metrics
  - name: Dependencies
  - name: Deploys
  - name: Discovery Audit
  - name: Docs
  - name: 'Eng Intel: 1-Registry'
  - name: 'Eng Intel: 2-Metrics'
  - name: 'Eng Intel: 3-Trace'
  - name: 'Eng Intel: User Labels'
  - name: Entity Relationship Types
  - name: Entity Relationships
  - name: Entity Types
  - name: GitOps Logs
  - name: Groups
  - name: IP Allowlist
  - name: Initiatives
  - name: My Workspace
  - name: Notification Logs
  - name: On-call
  - name: Packages
  - name: Plugins
  - name: Queries
  - name: SCIM
  - name: Scaffolder
  - name: Scorecards
  - name: Secrets
  - name: Team Roles
  - name: Teams
  - name: Teams Hierarchies
  - name: Teams [Advanced]
  - name: Teams [Departments] (legacy)
  - name: Users
  - name: Verifications
  - name: Workflows
  - name: '[Integrations] AWS'
  - name: '[Integrations] Anthropic'
  - name: '[Integrations] Apiiro'
  - name: '[Integrations] ArgoCD'
  - name: '[Integrations] Azure Active Directory'
  - name: '[Integrations] Azure Devops'
  - name: '[Integrations] Azure Resources'
  - name: '[Integrations] BambooHR'
  - name: '[Integrations] Bitbucket'
  - name: '[Integrations] Bugsnag'
  - name: '[Integrations] Buildkite'
  - name: '[Integrations] Checkmarx SAST'
  - name: '[Integrations] CircleCI'
  - name: '[Integrations] ClickUp'
  - name: '[Integrations] Codecov'
  - name: '[Integrations] Coralogix'
  - name: '[Integrations] Datadog'
  - name: '[Integrations] Dynatrace'
  - name: '[Integrations] Firehydrant'
  - name: '[Integrations] GitHub'
  - name: '[Integrations] GitLab'
  - name: '[Integrations] Harness'
  - name: '[Integrations] Incident.io'
  - name: '[Integrations] Instana'
  - name: '[Integrations] Jenkins'
  - name: '[Integrations] Jira'
  - name: '[Integrations] Kubernetes'
  - name: '[Integrations] LaunchDarkly'
  - name: '[Integrations] Lightstep'
  - name: '[Integrations] Mend SAST'
  - name: '[Integrations] Mend SCA'
  - name: '[Integrations] New Relic'
  - name: '[Integrations] Okta'
  - name: '[Integrations] Opsgenie'
  - name: '[Integrations] PagerDuty'
  - name: '[Integrations] Prometheus'
  - name: '[Integrations] Rollbar'
  - name: '[Integrations] Rootly'
  - name: '[Integrations] Semgrep'
  - name: '[Integrations] Sentry'
  - name: '[Integrations] ServiceNow'
  - name: '[Integrations] SignalFx'
  - name: '[Integrations] Snyk'
  - name: '[Integrations] SonarQube'
  - name: '[Integrations] SumoLogic'
  - name: '[Integrations] Veracode'
  - name: '[Integrations] VictorOps'
  - name: '[Integrations] Wiz'
  - name: '[Integrations] Workday'
  - name: '[Integrations] xMatters'
  - name: dev-login-controller
  - name: public-scim-schema-controller
paths:
  /api/v1/plugins:
    post:
      tags:
        - Plugins
      summary: Create a plugin
      description: Create a new plugin
      operationId: createPlugin
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreatePluginRequest'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PluginMetadata'
          description: Metadata of the created plugin
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Invalid request
        '429':
          $ref: '#/components/responses/TooManyRequests'
components:
  schemas:
    CreatePluginRequest:
      required:
        - blob
        - contexts
        - isDraft
        - minimumRoleRequired
        - name
        - tag
      type: object
      properties:
        blob:
          type: string
          description: The raw source code of the plugin. This should be an HTML file
        contexts:
          type: array
          description: >-
            Which contexts the plugin should execute/show up in, e.g. `{ "type":
            "GLOBAL" }`
          items:
            $ref: '#/components/schemas/CortexPluginContext'
        description:
          type: string
          description: Description of the plugin
        iconTag:
          type: string
          description: Icon tag for the plugin
        isDraft:
          type: boolean
          description: Whether the plugin is generally available or not
        minimumRoleRequired:
          type: string
          description: >-
            The minimum role required to view the plugin, e.g. `VIEWER`, `USER`,
            `MANAGER`, `OWNER`, or the tag for a custom role. Learn more about
            each permission in our
            [docs](https://docs.cortex.io/docs/walkthroughs/workspace-settings/permissioning#roles-in-cortex).
        name:
          type: string
          description: Display name of the plugin
        proxyTag:
          type: string
          description: The identifier of the proxy to use for requests from this plugin
        tag:
          type: string
          description: Unique identifier for the plugin
        version:
          type: string
          description: The version of the plugin
    PluginMetadata:
      required:
        - contexts
        - isDraft
        - lastUpdated
        - minimumRoleRequired
        - name
        - tag
      type: object
      properties:
        contexts:
          type: array
          description: >-
            Which contexts the plugin should execute/show up in, e.g. `{ "type":
            "GLOBAL" }`
          items:
            $ref: '#/components/schemas/CortexPluginContext'
        createdBy:
          $ref: '#/components/schemas/CortexUserDefinition'
        description:
          type: string
          description: Description of the plugin
        iconTag:
          type: string
          description: Icon tag for the plugin
        isDraft:
          type: boolean
          description: Whether the plugin is generally available or not
        lastUpdated:
          type: string
          description: When the plugin was last updated
        minimumRoleRequired:
          type: string
          description: >-
            The minimum role required to view the plugin, e.g. `VIEWER`, `USER`,
            `MANAGER`, `OWNER`, or the tag for a custom role. Learn more about
            each permission in our
            [docs](https://docs.cortex.io/docs/walkthroughs/workspace-settings/permissioning#roles-in-cortex).
        name:
          type: string
          description: Display name of the plugin
        proxyTag:
          type: string
          description: The identifier of the proxy to use for requests from this plugin
        tag:
          type: string
          description: Unique identifier for the plugin
        version:
          type: string
          description: The version of the plugin
    ErrorResponse:
      required:
        - message
        - type
      type: object
      properties:
        details:
          type: string
        errorCode:
          type: string
        gatewayHttpStatus:
          type: integer
          format: int32
        httpStatus:
          type: integer
          format: int32
        message:
          type: string
        requestId:
          type: string
        type:
          type: string
          enum:
            - INTEGRATION_MISSING
            - INTEGRATION_UNREGISTERED
            - INTEGRATION_UNSUPPORTED
            - INTEGRATION_GRAPHQL_ERROR
            - INTEGRATION_BAD_REQUEST
            - INTEGRATION_UNAUTHORIZED
            - INTEGRATION_FORBIDDEN
            - INTEGRATION_NOT_FOUND
            - INTEGRATION_UNPROCESSABLE_CONTENT
            - INTEGRATION_RATE_LIMITED
            - INTEGRATION_INTERNAL_ERROR
            - INTEGRATION_NOT_IMPLEMENTED
            - INTEGRATION_BAD_GATEWAY
            - INTEGRATION_UNAVAILABLE
            - INTEGRATION_GATEWAY_TIMEOUT
            - INTEGRATION_TIMED_OUT
            - INTEGRATION_CACHE_ERROR
            - INTEGRATION_UNHANDLED_HTTP_ERROR
            - INTEGRATION_UNHANDLED_EXCEPTION
            - INTEGRATION_UNEXPECTED_ERROR
            - ILLEGAL_ARGUMENT_ERROR
            - BAD_REQUEST
            - FORBIDDEN
            - NOT_FOUND
            - REQUEST_TIMEOUT
            - CONFLICT
            - UNHANDLED_EXCEPTION
            - UNCATEGORIZED
            - SERVICE_CREATOR
            - UNKNOWN_HOST
            - TOO_MANY_REQUESTS
    CortexPluginContext:
      required:
        - type
      type: object
      properties:
        type:
          type: string
      description: >-
        Which contexts the plugin should execute/show up in, e.g. `{ "type":
        "GLOBAL" }`
      discriminator:
        propertyName: type
      oneOf:
        - $ref: '#/components/schemas/ENTITY'
        - $ref: '#/components/schemas/GLOBAL'
    CortexUserDefinition:
      required:
        - dateCreated
        - email
        - name
        - oauthUserId
        - tenantId
      type: object
      properties:
        dateCreated:
          type: string
          format: date-time
        email:
          type: string
        id:
          type: integer
          format: int64
        lastLogin:
          type: string
          format: date-time
        name:
          type: string
        oauthUserId:
          type: string
        tenantId:
          type: integer
          format: int64
        timezone:
          type: string
      description: The creator of the plugin. Null if created via API.
    TooManyRequestsProblemDetail:
      required:
        - type
        - title
        - status
      type: object
      properties:
        detail:
          type: string
        instance:
          type: string
          format: uri-reference
        retryAfter:
          minimum: 0
          type: integer
          description: The number of seconds until the rate limiting resets.
          format: int32
        status:
          maximum: 599
          minimum: 100
          type: integer
          format: int32
          enum:
            - 429
        title:
          type: string
        type:
          type: string
          format: uri-reference
    ENTITY:
      type: object
      allOf:
        - $ref: '#/components/schemas/CortexPluginContext'
        - type: object
          properties:
            entityFilter:
              $ref: '#/components/schemas/EntityFilter'
    GLOBAL:
      type: object
      allOf:
        - $ref: '#/components/schemas/CortexPluginContext'
    EntityFilter:
      required:
        - type
      type: object
      properties:
        type:
          type: string
          enum:
            - CQL_FILTER
            - SERVICE_FILTER
            - RESOURCE_FILTER
            - DOMAIN_FILTER
            - TEAM_FILTER
            - COMPOUND_FILTER
      discriminator:
        propertyName: type
      oneOf:
        - $ref: '#/components/schemas/CQL_FILTER'
        - $ref: '#/components/schemas/SERVICE_FILTER'
        - $ref: '#/components/schemas/RESOURCE_FILTER'
        - $ref: '#/components/schemas/DOMAIN_FILTER'
        - $ref: '#/components/schemas/TEAM_FILTER'
        - $ref: '#/components/schemas/COMPOUND_FILTER'
    CQL_FILTER:
      type: object
      allOf:
        - $ref: '#/components/schemas/EntityFilter'
        - required:
            - category
            - query
          type: object
          properties:
            category:
              type: string
              enum:
                - Service
                - Resource
                - Domain
                - Team
                - Generic
            cqlVersion:
              type: string
              enum:
                - V1
                - V2
            query:
              type: string
    SERVICE_FILTER:
      type: object
      allOf:
        - $ref: '#/components/schemas/EntityFilter'
        - type: object
          properties:
            entityGroupFilter:
              $ref: '#/components/schemas/EntityGroupFilterDTO'
    RESOURCE_FILTER:
      type: object
      allOf:
        - $ref: '#/components/schemas/EntityFilter'
        - type: object
          properties:
            entityGroupFilter:
              $ref: '#/components/schemas/EntityGroupFilterDTO'
            typeFilter:
              $ref: '#/components/schemas/EntityTypeFilter'
    DOMAIN_FILTER:
      type: object
      allOf:
        - $ref: '#/components/schemas/EntityFilter'
        - type: object
          properties:
            entityGroupFilter:
              $ref: '#/components/schemas/EntityGroupFilterDTO'
    TEAM_FILTER:
      type: object
      allOf:
        - $ref: '#/components/schemas/EntityFilter'
        - type: object
          properties:
            entityGroupFilter:
              $ref: '#/components/schemas/EntityGroupFilterDTO'
    COMPOUND_FILTER:
      type: object
      allOf:
        - $ref: '#/components/schemas/EntityFilter'
        - type: object
          properties:
            cqlFilter:
              $ref: '#/components/schemas/CQL_FILTER'
            entityGroupFilter:
              $ref: '#/components/schemas/EntityGroupFilterDTO'
            typeFilter:
              $ref: '#/components/schemas/EntityTypeFilter'
    EntityGroupFilterDTO:
      required:
        - entityGroups
        - excludedEntityGroups
      type: object
      properties:
        entityGroups:
          uniqueItems: true
          type: array
          items:
            type: string
        excludedEntityGroups:
          uniqueItems: true
          type: array
          items:
            type: string
    EntityTypeFilter:
      required:
        - include
        - providers
        - types
      type: object
      properties:
        include:
          type: boolean
        providers:
          uniqueItems: true
          type: array
          items:
            type: string
            enum:
              - AWS
              - GCP
              - AZURE
        types:
          uniqueItems: true
          type: array
          items:
            type: string
  responses:
    TooManyRequests:
      content:
        application/problem+json:
          schema:
            $ref: '#/components/schemas/TooManyRequestsProblemDetail'
      description: >-
        The client has exceeded the rate limit by performing too many requests
        in a short period. Retry the request after a delay.
      headers:
        Retry-After:
          description: The number of seconds until the rate limiting resets.
          schema:
            minimum: 0
            type: integer
            format: int32
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      description: >-
        All requests to the Cortex API need to provide an `Authorization: Bearer
        <token>` header, where `<token>` is an API key created in the Settings
        page of your workspace.
      scheme: bearer
      type: http

````

## Related topics

- [Plugins](/api/rest/plugins.md)
- [Creating a plugin](/streamline/plugins/creating-plugins.md)
- [Creating a plugin proxy](/streamline/plugins/creating-plugins/plugin-proxy.md)
